#include "wrap/thread.h"
#include "wrap/synch.h"
#include <string.h>
#include <stdlib.h>
#include <stdio.h>

/**
 * Du har ett program som gör mycket tunga beräkningar. Du har dock tröttnat på
 * att det tar så lång tid att köra, så du tänkte dela upp beräkningarna på två
 * trådar i förhoppningen att det går snabbare att köra programmet.
 *
 * Du har kommit så långt att du har insett att problemet kan lösas genom att
 * köra funktionen "do_work" två gånger med olika parametrar och summera
 * resultatet. Problemet är dock att resultatet inte blir korrekt varje
 * gång. Ibland blir resultatet från den andra tråden 0...
 */


// Funktion som gör de tunga beräkningarna. Denna vill vi köra parallellt i två
// trådar.
int do_work(int param) {
    // Här sker tungt arbete...
    // Tips, testa att avkommentera följande rad för att se problemen tydligare.
    // timer_msleep(param);

    // För enkelhets skull returnerar vi bara parametern i kvadrat.
    return param * param;
}

// Parameter till tråden vi skapar.
int param;

// Resultat från tråden vi skapar.
int result;

// Den första funktionen som körs i den andra tråden.
void thread_main(int *dummy) {
    result = do_work(param);
}

int main(void) {
    // Beräkna "do_work(100)" i den andra tråden.
    param = 100;
    thread_new(&thread_main, NULL);

    // Beräkna "do_work(50)" i den här tråden.
    int here = do_work(50);

    printf("From other thread: %d\n", result);
    printf("From here: %d\n", here);
    printf("Sum: %d\n", result + here);

    return 0;
}
